#!/usr/bin/env ruby

# Properties in the catalog:
#     name: string
#     city: string
#     venue: string
#     date: timestamp
#     genres: set
#     price: double

# Example item:
#     name: "New York Philharmonic: Rachmaninoff",
#     city: "New York",
#     venue: "Lincoln Center",
#     date:  "2017-12-10",
#     genre: ["classical music"],
#     price: 94.0

require 'recombee_api_client'
include RecombeeApiClient

require 'pp'

client = RecombeeClient.new('events-example', 'PbBaEVxx8ZOj0x3BhGtqfHyi8qQ8rm8rE1JBnSPoCnHwetzO3gjHer96YVAIa14G')

recommended = client.send(RecommendItemsToItem.new('nyphilharmonic181210', 'user-27', 3, :cascade_create => true))
pp recommended

recommended = client.send(RecommendItemsToItem.new('nyphilharmonic181210', 'user-27', 3, :return_properties => true))
pp recommended
puts("\n'city' == \"New York\":")
recommended = client.send(RecommendItemsToItem.new('nyphilharmonic181210', 'user-27', 3,
                                                :return_properties => true,
                                                :filter => "'city' == \"New York\""))
pp recommended
puts("\n'city' == \"New York\" AND 'date' >= now():")
recommended = client.send(RecommendItemsToItem.new('nyphilharmonic181210', 'user-27', 3,
                                                :return_properties => true,
                                                :filter => "'city' == \"New York\" AND 'date' >= now()"))
pp recommended
puts("\n'city' == \"New York\" AND 'date' >= now() AND \"ballet\" in 'genres':")
recommended = client.send(RecommendItemsToItem.new('nyphilharmonic181210', 'user-27', 3,
                                                :return_properties => true,
                                                :filter => "'city' == \"New York\" AND 'date' >= now() AND \"ballet\" in 'genres'"))
pp recommended

puts("\n'city' == context_item[\"city\"] AND 'date' >= now() AND \"ballet\" in 'genres':")
recommended = client.send(RecommendItemsToItem.new('nyphilharmonic181210', 'user-27', 3,
                                                :return_properties => true,
                                                :filter => "'city' == context_item[\"city\"] AND 'date' >= now() AND \"ballet\" in 'genres'"))
pp recommended
puts("\n'city' == context_item[\"city\"] AND 'date' >= now() AND \"ballet\" in 'genres' for laphilharmonic190525:")
recommended = client.send(RecommendItemsToItem.new('laphilharmonic190525', 'user-27', 3,
                                                :return_properties => true,
                                                :filter => "'city' == context_item[\"city\"] AND 'date' >= now() AND \"ballet\" in 'genres'"))

pp recommended

